{$A+,B+,D-,E+,F-,G+,I-,L-,N-,O-,R-,S-,V-,X+}
{****************************************************************************
 * Author           : Stefan Goehler, Germany                               *
 * Version          : official 1.11                                         *
 * Task             : Mousedriver for the unit graphics                     *
 * Copyright        : Do what u want to do with this, but mention me!       *
 *                    But if you want too use it in commercial products - I *
 *                    mean if you want to get any money for the software    *
 *                    with this unit, please contact me and I'll give you   *
 *                    my OK or not.                                         *
 * OBJ-FILES        : ms(cursor);hand;wait(hourglass);txt(textedit)         *
 *******                                                                    *
 * I don't know any bugs - if there are any, please email me:               *
 * goehler@geocities.com                                                    *
 * my homepage      : www.geocities.com/SiliconValley/Bay/9553              *
 *******                                                                    *
 * History                                                                  *
 * Version 1.0 : first public availible Version (11. Aug. 1997)             *
 * Version 1.1 : +added support to specify the area to move (setmousearea)  *
 *               +added procedure setmousepos to set cursorposition         *
 * Version 1.11: *changed all a little bit so that it can run correctly with*
 *                setviewport                                               *
 ****************************************************************************}

unit mousedr7;
interface
uses dos,graphics;
type tpoint = record
     x,y    : word;
     end;
const
sensitivy   : byte = 0;{Speed of the cursor}
cursor      : byte = 1;{Actual cursor}
buttons     : byte = 0;{pressed buttons; internal}
win95active : boolean = false;
var
msx,msy   : integer;{posx,posy; internal}
ps        : tpoint ;{internal}
event     : record {public record filled by getmouseevent}
  Buttons : Byte   ;
  what    : integer;
  Where   : TPoint ;
  end;
mactive   : byte   ;{hidemouse increases, showmouse decreases this number -
                     to give showmouse the information, how much hidemouse
                     was called and showmouse should be called to see the
                     cursor}
movearea  : record
x1,y1,x2,y2 : integer;
end;

{const
convert : array[0..15] of integer=(0,4,2,6,1,5,3,7,8,12,10,14,9,13,11,15);}

procedure initevents   ;{should be called after set256mode}
procedure doneevents   ;{should be called before closegraph}
procedure showmouse    ;{show the mouse}
procedure hidemouse    ;{show the mouse}
procedure getmouseevent;{get the mouse events}
procedure notmovemouse ;{stop the mousemoving, but don't hide the mouse -
                        to do some graphical actions without overdraw the mousecursor}
procedure letmovemouse;{call it, when you have finished the drawings after notmovemouse}
procedure changecursor(c : byte);{change the actual cursor}
function  mousethere(x1,y1,x2,y2 : integer) : boolean;{this function checks,
              if there is any part of the cursor in the specified rectangle}
function  pointerthere(x1,y1,x2,y2 : integer) : boolean;{this function checks,
                 if there is the top of the cursor in the specified rectangle}
procedure setmousearea(x1,y1,x2,y2 : integer);
procedure setmousepos(x,y : integer);

implementation
var
olmsx,olmsy,i     : integer;{last positions}
mP,mPp,mp2        : Pointer;{mousecursor in the memory}
mssize            : Word   ;{memory size of the cursor (x*y+4)}
first,active,run  : boolean;{first : first draw on the screen (after showmouse)
                             active: was already initmouse called?
                             run   : can the mousecursor be moved?}
procedure ms; external;
{$L MS.OBJ }
procedure hand; external;
{$L HAND.OBJ }
procedure wait; external;
{$L WAIT.OBJ }
{procedure arrows; external;}
{-$L arrows.OBJ }
procedure txt; external;
{$L TXT.OBJ }

function mousethere(x1,y1,x2,y2 : integer) : boolean;
begin
if (msx+mousedr7.ps.x < x1)or(msy+mousedr7.ps.y < y1)or
   (msx > x2)or(msy > y2) then mousethere := false
                       else mousethere := true;
end;
function pointerthere(x1,y1,x2,y2 : integer) : boolean;
begin
if (event.where.x < x1)or(event.where.y < y1)or
   (event.where.x > x2)or(event.where.y > y2) then pointerthere := false
                         else pointerthere := true;
end;

procedure move2(var input,output;size : word);assembler;
asm
mov dx,ds
lds si,input
les di,output
mov cx,size
mov ax,cx
cmp cx,4
jb @not4
shr cx,2
db 0F3h,66h,0A5h{rep movsd}

 mov cx,ax
 and cx,11b
 @not4:
rep movsb
@end:
mov ds,dx
end;

procedure drawproc;far;assembler;
var
  vp : viewporttype;
asm
{save old viewport values}
mov ax,viewport.x1
mov vp.x1,ax
mov ax,viewport.y1
mov vp.y1,ax
mov ax,viewport.x2
mov vp.x2,ax
mov ax,viewport.x2
mov vp.y2,ax
mov ax,viewport.mxx
mov vp.mxx,ax
mov ax,viewport.mxy
mov vp.mxy,ax
{set new values - because mouse should always run over the full screen}
mov viewport.x1,0
mov viewport.y1,0
mov ax,mxx
mov viewport.x2,ax
mov viewport.mxx,ax
mov ax,mxy
mov viewport.y2,ax
mov viewport.mxy,ax

cmp first,0
jne @isfirst
push olmsx
push olmsy
push word ptr mP[2]
push word ptr mP
call putimage
@isfirst:
mov ax,mxx
sub ax,ps.x
{cmp msx,ax
jnb @amRand}

mov ax,msx
add ax,ps.x
mov bx,msy
add bx,ps.y
push msx
push msy
push ax
push bx
push word ptr mP[2]
push word ptr mP
call getimage

push word ptr mp[2];push word ptr mp
push word ptr mpp[2];push word ptr mpp
push mssize
call move2
mov dx,ds
mov cx,mssize
mov bx,4
sub cx,bx
les di,mp2
lds si,mpp
add di,bx
add si,bx
@lp:
mov ax,es:[di]
or al,al
jz @next2
mov ds:[si],al
@next2:
inc si
or ah,ah
jz @next
mov ds:[si],ah


@next:
{add bx,2}
add di,2
inc si
{cmp bx,cx
jng @lp}
sub cx,2
jnz @lp
mov ds,dx
(*
{removed because the putimage-function of graphics automaticly clips
the cursor on edges}
jmp @end
@amRand:
mov ax,msx
mov cx,mxx
sub cx,ax
add ax,cx
mov bx,msy
add bx,ps.y
push msx
push msy
push ax
push bx
push word ptr mP[2]
push word ptr mP
call getimage

push word ptr mp[2];push word ptr mp
push word ptr mpp[2];push word ptr mpp
push mssize
call move2
mov i2,3
xor si,si
mov cx,mxx
sub cx,msx
add cx,4
@lp4:
mov bx,4
@lp3:
inc i2
mov es,sg
mov ax,ps.x
inc ax
mul si
add ax,os
add ax,bx{i2}
mov di,ax
mov al,es:[di]
or al,al
jz @next3

les di,mpp
add di,i2

mov es:[di],al
@next3:
inc bx
cmp bx,cx
jng @lp3

inc si
cmp si,ps.y
jng @lp4
@end:*)
push msx
push msy
push word ptr mPp[2]
push word ptr mPp[0]
call putimage
{restore old viewport values}
mov ax,vp.x1
mov viewport.x1,ax
mov ax,vp.y1
mov viewport.y1,ax
mov ax,vp.x2
mov viewport.x2,ax
mov ax,vp.y2
mov viewport.x2,ax
mov ax,vp.mxx
mov viewport.mxx,ax
mov ax,vp.mxy
mov viewport.mxy,ax
end;

procedure mouse;far;assembler;
var sds : word;
    asm
      mov sds,ds
      mov si,seg @DATA
      mov ds,si
      cmp run,0
      je @notrun
      mov ax,msx
      mov olmsx,ax
      mov ax,msy
      mov olmsy,ax
      mov ax,000bh
      int 33h
      cmp sensitivy,0
      je @next
      sar cx,1
      sar dx,1
      @next:
      mov si,msx
      mov di,msy
      add si,cx
      add di,dx
    mov ax,movearea.x1
    cmp si,ax
    jnl @cxnotb0
    mov si,ax
    @cxnotb0:
    cmp si,movearea.x2
    jna @cxnotamxx
    mov si,movearea.x2
    @cxnotamxx:

    mov ax,movearea.y1
    cmp di,ax
    jnl @dxnotb0
    mov di,ax
    @dxnotb0:
    cmp di,movearea.y2
    jna @dxnotamxy
    mov di,movearea.y2
    @dxnotamxy:
    mov msx,si
    mov msy,di
call drawproc
mov first,0
mov ds,sds
@notrun:
end;

procedure mouse2;assembler;
asm
call drawproc
mov first,0
end;


procedure setmousearea(x1,y1,x2,y2 : integer);
var temp : boolean;
begin
hidemouse;
movearea.x1 := x1;
movearea.y1 := y1;
movearea.x2 := x2;
movearea.y2 := y2;
if (msx < movearea.x1) then msx := movearea.x1;
if (msy < movearea.y1) then msy := movearea.y1;
if (msx > movearea.x2) then msx := movearea.x2;
if (msy > movearea.y2) then msy := movearea.y2;
showmouse;
end;

procedure setmousepos(x,y : integer);
begin
hidemouse;
msx := x;
msy := y;
if (msx < movearea.x1) then msx := movearea.x1;
if (msy < movearea.y1) then msy := movearea.y1;
if (msx > movearea.x2) then msx := movearea.x2;
if (msy > movearea.y2) then msy := movearea.y2;
showmouse;
end;

procedure notmovemouse;assembler;
asm
mov run,0
end;
procedure letmovemouse;assembler;
asm
mov al,mactive
or al,al
jnz @end
mov run,1
@end:
end;


procedure showmouse;assembler;
asm
mov cl,mactive
mov bl,1
mov al,active
or al,al
jz @end
mov first,bl
cmp cl,bl
jg @end2
 mov first,1
{  xor cl,cl}
 call mouse2
mov run,1
jmp @end
@end2:
dec cl
@end:
mov mactive,cl
end;
procedure hidemouse;assembler;
asm
  cmp active,0
  je @end
  xor al,al
  mov run,al
  inc mactive
  cmp first,1
  je @end
  mov first,al
  push msx
  push msy
  push word ptr mp[2]
  push word ptr mp[0]
  call putimage
  @end:
end;


procedure changecursor(c : byte);
begin
if cursor <> c then begin
cursor := c;
hidemouse;
freeMem(mPp, mssize);
freeMem(mP , mssize);
case cursor of
1 : mp2 := @MS;
2 : mp2 := @HAND;
3 : mp2 := @WAIT;
4 : mp2 := @TXT;
{5 : mp2 := @ARROWS;
6 : mp2 := ptr(seg(@arrows^),ofs(@arrows^)+21*21);
7 : mp2 := ptr(seg(@arrows^),ofs(@arrows^)+21*21*2);
8 : mp2 := ptr(seg(@arrows^),ofs(@arrows^)+21*21*3);}
else cursor := 1;
end;
if (cursor > 4)and(cursor < 9) then begin
ps.x := 20;
ps.y := 20;
end else getimagesize(mp2,ps.x,ps.y);
mssize := ImageSize(0,0,ps.x,ps.y);
GetMem(mPp, mssize);
GetMem(mP , mssize);
showmouse;
end;
end;


procedure initevents;
begin
if not gfx_inited then
begin
writeln('Mousedriver-error: you can''t use the mouse without initializing the graphics',#7);
halt(20);
end;
active := true;
first := true;
run := true;
getimagesize(mp2,ps.x,ps.y);
  mssize := ImageSize(0,0,ps.x,ps.y);
  GetMem(mPp, mssize);
  GetMem(mP , mssize);
movearea.x1 := 0;
movearea.y1 := 0;
movearea.x2 := mxx;
movearea.y2 := mxy;
asm
{Zeiger auf Darstellungsprozedur}
mov ax,12
mov cx,0FFFFh
mov dx,OFFSET CS:Mouse
push cs
pop  es
int 33h
{Relative Mausposition auslesen(resettet)}
mov ax,000bh
int 33h
end;
mactive := 0;
end;


procedure doneevents;
begin
if active then begin
hidemouse;
asm
MOV AX,12
XOR CX,CX
MOV DX,CX
MOV ES,CX
INT 33H
end;
active := false;
FreeMem(mP, mssize);
FreeMem(mPp, mssize);
end;
end;

procedure getmouseevent;assembler;
asm
mov al,active
or al,al
jz @notchanged
{cmp run,0
jne @mouseon
call getcoordinates
@mouseon:}
mov al,event.buttons
mov buttons,al
xor ax,ax
mov event.what,ax
mov ax,3
int 33h
cmp bl,event.buttons
jne @end
mov event.what,8
@end:
mov event.buttons,bl

mov ax,msx
mov bx,msy
mov event.where.x,ax
mov event.where.y,bx
mov al,buttons
mov bl,event.buttons
cmp al,bl
je @notchanged
or al,al
jz @next
mov event.what,2
jmp @notchanged
@next:
or bl,bl
jz @notchanged
mov event.what,1
@notchanged:
end;

function currenttime : longint;assembler;
asm
xor ah,ah
int 1Ah
mov ax,dx
mov dx,cx
end;
var count,endtime : longint;

var
i2,a,b,c : integer;
i1       : longint;
begin
asm
xor ax,ax
xor bx,bx
int 33h
mov i,ax
end;
if i = 0 then begin
writeln('Error: mousedriver required!');
halt(2);
end;


{mp2 := @WAIT;
getimagesize(mp2,ps.x,ps.y);
for i:= 0 to (ps.x+1)*(ps.y+1)-1 do
if Mem[Seg(mp2^):Ofs(mp2^)+i+4] < 16 then Mem[Seg(mp2^):Ofs(mp2^)+i+4] :=convert[Mem[Seg(mp2^):Ofs(mp2^)+i+4]];
{mp2 := @HAND;
getimagesize(mp2,ps.x,ps.y);
for i:= 0 to (ps.x+1)*(ps.y+1)-1 do
if Mem[Seg(mp2^):Ofs(mp2^)+i+4] < 16 then Mem[Seg(mp2^):Ofs(mp2^)+i+4] :=convert[Mem[Seg(mp2^):Ofs(mp2^)+i+4]];}
mp2 := @MS;
getimagesize(mp2,ps.x,ps.y);
{for i:= 0 to (ps.x+1)*(ps.y+1)-1 do
if Mem[Seg(mp2^):Ofs(mp2^)+i+4] < 16 then Mem[Seg(mp2^):Ofs(mp2^)+i+4] :=convert[Mem[Seg(mp2^):Ofs(mp2^)+i+4]];}
    asm
      mov ax,160Ah
      int 2Fh
      mov i,bx
    End;
if i <> 0 then if i shr 8 >= 4 then win95active := true;
asm
xor ax,ax
int 33h
end;
end.






